Qore::BinaryInputStream Class Reference

This class implements the InputStream interface for reading bytes from a Binary variable. More...

Inheritance diagram for Qore::BinaryInputStream:
[legend]

## Public Member Functions

| constructor (data src)
| Creates the BinaryInputStream based on the Binary given. More...
int | peek ()
| Peeks the next byte available from the input stream; returns -1 if no more data available. More...
*binary | read (int limit)
| Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream. More...
Public Member Functions inherited from Qore::InputStream
| constructor ()
| Constructor. More...
Public Member Functions inherited from Qore::StreamBase
| constructor ()
| Throws an exception if called directly; this class can only be instantiated by builtin subclasses. More...
int | getThreadId ()
| Get the currently assigned thread id or -1 if not assigned to any thread.
nothing | reassignThread ()
| Reassigns current thread as thread used for stream manipulation. More...
nothing | unassignThread ()
| Unassigns current thread as thread used for stream manipulation. More...

## Detailed Description

This class implements the InputStream interface for reading bytes from a Binary variable.

Example: BinaryInputStream basic usage
  binary src = <2AFF04>;
  BinaryInputStream bis(src);
  *binary b;
  while (b = bis.read(2)) {
  printf("read %d\n", make_hex_string(b));
  }
  read 2AFF
  read 04

Note
  stream classes are not designed to be accessed from multiple threads; they have been implemented without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause a `STREAM-THREAD-ERROR` to be thrown, unless the stream is handed off to another thread using the StreamBase::unassignThread() method in the thread that currently owns the stream, and the StreamBase::reassignThread() method in the new thread.

See also
  StreamReader for a class that can be used to read various kinds of data from an InputStream

Since
  Qore 0.8.13

## Member Function Documentation

## constructor()

Qore::BinaryInputStream::constructor | ( | data | src | ) |

Creates the BinaryInputStream based on the Binary given.

Parameters

  src | the Binary or string to read bytes from

Since
  Qore 0.9.4 this constructor also accepts strings

## peek()

int Qore::BinaryInputStream::peek | ( |  | ) |

virtual

Peeks the next byte available from the input stream; returns -1 if no more data available.

Returns
  the next byte available from the input stream or -1 if no more data is available

Example:
  binary src = <2AFF04>;
  BinaryInputStream is(src);
  printf("peek: %d\n", is.peek());
  *binary b = is.read(3);
  printf("peek: %d\n", is.peek());
  peek 42
  peek -1

Exceptions

  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::InputStream.

## read()

*binary Qore::BinaryInputStream::read | ( | int | limit | ) |

virtual

Reads bytes (up to a specified limit) from the input stream; returns NOTHING if there are no more bytes in the stream.

Parameters

  limit | the maximum number of bytes to read

Returns
  the read bytes (the length is between 1 and `limit` inclusive) or NOTHING if no more bytes are available

Example:
  binary src = <2AFF04>;
  BinaryInputStream is(src);
  *binary b;
  while (b = is.read(2)) {
  printf("read %s\n", make_hex_string(b));
  }
  read 2aff
  read 04

Exceptions

  INPUT-STREAM-ERROR | limit is not positive
  STREAM-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Implements Qore::InputStream.